VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CDemoMode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' *************************************************************
'  Copyright 1999, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb/
' *************************************************************
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Private Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long

Private m_ModFileName As String
Private m_EnvFileName As String

Private Const MAX_PATH = 260

Private Sub Class_Initialize()
   Dim buffer As String
   
   buffer = Space(MAX_PATH)
   Call GetModuleFileName(App.hInstance, buffer, Len(buffer))
   m_ModFileName = TrimNull(buffer)
End Sub

Public Property Get AppExeName() As String
   AppExeName = App.EXEName
End Property

Public Property Get EnvFileName() As String
   EnvFileName = m_EnvFileName
End Property

Public Property Get IdeMapped() As Boolean
   IdeMapped = TestEnvs
End Property

Public Property Get ModuleFileName() As String
   ModuleFileName = m_ModFileName
End Property

Private Function TestEnvs() As Boolean
   Dim buffer As String
   Dim Envs As Variant
   Dim nRet As Long
   Dim i As Long
   
   ' Fill array with the names of all environments in which
   ' you want users to be able to use your DLL.
   Envs = Array("vb.exe", "vb32.exe", "vb5.exe", "vb6.exe")
   
   ' Test each array element with GetModuleHandle to see
   ' if that environment is mapped into the current process.
   For i = LBound(Envs) To UBound(Envs)
      buffer = Envs(i)
      nRet = GetModuleHandle(buffer)
      If nRet <> 0 Then
         m_EnvFileName = buffer
         TestEnvs = True
         Exit For
      End If
   Next i
End Function

Private Function TrimNull(ByVal StrIn As String) As String
   Dim nul As Long
   '
   ' Truncate input string at first null.
   ' If no nulls, perform ordinary Trim.
   '
   nul = InStr(StrIn, vbNullChar)
   Select Case nul
      Case Is > 1
         TrimNull = Left(StrIn, nul - 1)
      Case 1
         TrimNull = ""
      Case 0
         TrimNull = Trim(StrIn)
   End Select
End Function

