VERSION 5.00
Object = "{307C5043-76B3-11CE-BF00-0080AD0EF894}#1.0#0"; "MSGHOO32.OCX"
Begin VB.Form GrabMe 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox Check1 
      Caption         =   "Display Sizing Grip"
      Height          =   315
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2715
   End
   Begin MsghookLib.Msghook Msghook1 
      Left            =   2100
      Top             =   1380
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
   End
End
Attribute VB_Name = "GrabMe"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *************************************************************
'  Copyright 1999, Karl E. Peterson, All Rights Reserved.
'  http://www.mvps.org/vb/
' *************************************************************
'  Special thanks to Brad Martinez, who originated the concept.
'  http://members.aol.com/btmtz/vb/index.htm
' *************************************************************
'  Author grants royalty-free rights to use this code within
'  compiled applications. Selling or otherwise distributing
'  this source code is not allowed without author's express
'  permission.
' *************************************************************
Option Explicit

' Win32 API Declarations
Private Declare Function InvalidateRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT, ByVal bErase As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function PtInRect Lib "user32" (lpRect As RECT, ByVal ptY As Long, ByVal ptX As Long) As Long
Private Declare Function DrawFrameControl Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Long
Private Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Type RECT
   Left As Long
   Top As Long
   Right As Long
   Bottom As Long
End Type

' Flags for GetSystemMetrics
Private Const SM_CXSIZE = 30
Private Const SM_CYSIZE = 31

' Flags for DrawFrameControl
Private Const DFC_SCROLL = 3
Private Const DFCS_SCROLLSIZEGRIP = &H8

' Messages to hook
Private Const WM_PAINT = &HF
Private Const WM_NCHITTEST = &H84
Private Const WM_SIZE = &H5

' WM_NCHITTEST and MOUSEHOOKSTRUCT Mouse Position Codes
Private Const HTBOTTOMRIGHT = 17

' Private flags
Private m_Sizable As Boolean

Private Sub Check1_Click()
   ' Toggle flag for size grip and redraw form.
   m_Sizable = (Check1.Value = vbChecked)
   Me.Refresh
End Sub

Private Sub Form_Load()
   ' Basic demo niceties.
   Set Me.Icon = Nothing
   Me.Caption = "Size Gripper Demo"
   Check1.Value = vbChecked

   ' Set up subclassing.
   Msghook1.HwndHook = Me.hWnd
   Msghook1.Message(WM_PAINT) = True
   Msghook1.Message(WM_NCHITTEST) = True
   Msghook1.Message(WM_SIZE) = True
End Sub

Private Sub Msghook1_Message(ByVal msg As Long, ByVal wp As Long, ByVal lp As Long, result As Long)
   Static rc1 As RECT
   Static rc2 As RECT
    
   If m_Sizable Then
      Select Case msg
         Case WM_SIZE
            ' Check if previous grip was drawn on visible
            ' surface. (Won't be the case if form was sized
            ' down very rapidly.) If so, just invalidate
            ' that region. If not, force a repaint.
            Call GetClientRect(Me.hWnd, rc2)
            If PtInRect(rc2, rc1.Left, rc1.Top) Then
               Call InvalidateRect(Me.hWnd, rc1, True)
            Else
               Call PostMessage(Me.hWnd, WM_PAINT, 0, 0)
            End If
            
            ' Proceed with default processing.
            result = Msghook1.InvokeWindowProc(msg, wp, lp)
         
         Case WM_PAINT
            ' Must allow the window to process the msg before
            ' the size grip is drawn, or things will get messed up...
            result = Msghook1.InvokeWindowProc(msg, wp, lp)
            
            ' Draw a new size grip...
            Call GetClientRect(Me.hWnd, rc1)
            rc1.Left = rc1.Right - GetSystemMetrics(SM_CXSIZE)
            rc1.Top = rc1.Bottom - GetSystemMetrics(SM_CYSIZE)
            Call DrawFrameControl(Me.hDC, rc1, DFC_SCROLL, DFCS_SCROLLSIZEGRIP)
         
         Case WM_NCHITTEST
            ' If the cursor is over the drawn size grip, have the window
            ' proc set the NW-SE pointer, allows the area to size the dlg.
            Call GetWindowRect(Me.hWnd, rc2)
            rc2.Left = rc2.Right - GetSystemMetrics(SM_CXSIZE)
            rc2.Top = rc2.Bottom - GetSystemMetrics(SM_CYSIZE)
            If PtInRect(rc2, WordLo(lp), WordHi(lp)) Then
               result = HTBOTTOMRIGHT
            Else
               result = Msghook1.InvokeWindowProc(msg, wp, lp)
            End If
         
         Case Else
            ' This really shouldn't ever fire, but...?
            result = Msghook1.InvokeWindowProc(msg, wp, lp)
      End Select
   
   Else 'm_Sizable = False
      ' Allow default window message processing.
      result = Msghook1.InvokeWindowProc(msg, wp, lp)
   End If
End Sub

Private Function WordHi(LongIn As Long) As Integer
   Call CopyMem(WordHi, ByVal (VarPtr(LongIn) + 2), 2)
End Function

Private Function WordLo(LongIn As Long) As Integer
   Call CopyMem(WordLo, ByVal VarPtr(LongIn), 2)
End Function

